﻿#Region "Imports"
Imports System
Imports System.Collections.Generic
Imports System.Drawing
Imports Microsoft.VisualBasic
Imports Microsoft.VisualBasic.Constants
Imports Microsoft.VisualBasic.Conversion
Imports Microsoft.VisualBasic.DateAndTime
Imports Microsoft.VisualBasic.FileSystem
Imports Microsoft.VisualBasic.Financial
Imports Microsoft.VisualBasic.Globals
Imports Microsoft.VisualBasic.Information
Imports Microsoft.VisualBasic.Interaction
Imports Microsoft.VisualBasic.Strings
Imports Microsoft.VisualBasic.VBMath
Imports Plugins
Imports Plugins.Indicator
Imports Plugins.Strategy
Imports Tengoku.Kumo.Calc.Indicators
Imports Tengoku.Kumo.Charting.Chart
Imports Tengoku.Kumo.Charting.Frame
Imports Tengoku.Kumo.Charting.Scale
Imports Tengoku.VisualChart.Plugins.Attributes
Imports Tengoku.VisualChart.Plugins.Types
Imports VisualChart.Development.Runtime.DataSeries
Imports VisualChart.Development.Runtime.Plugins
#End Region

''' <summary>
''' Your indicator description here.
''' </summary>
<Indicator(Name:="CycloMestor", Description:="Your indicator description here")>
Public Class CycloMestor
    Inherits IndicatorPlugin
    '#Region "PDV Declarations"
    Dim SPM As Double 'Double
    Dim CycloMestor As Double 'Double
    Const Data1 As DataIdentifier = 0
    Dim StochasticData As DataIdentifier
    Dim Stochastic1Data As DataIdentifier
    Dim Stochastic2Data As DataIdentifier
    Dim Stochastic3Data As DataIdentifier
    '#End Region


    ' Parameter format example
    ''' <summary>
    ''' Your parameter description here.
    ''' </summary>
    ' <Parameter(Name := "period", DefaultValue := 15, MinValue := 2, MaxValue := 100, Step := 1)>
    ' Private period As Integer

    '' Indicator declaration sample
    '' Dim avSimple As AvSimple

    ''' <summary>
    ''' This method is used to configure the indicator and is called once before any indicator method is called.
    ''' </summary> 
    Public Overrides Sub OnInitCalculate()
        '#Region "PDV Initializations"
        SPM = 0
        CycloMestor = 0
        Dim StochasticDataParameters() As Object = {5, 9, 3, AvgType.Exponential, 80.0, 20.0}
        StochasticData = GetIndicatorIdentifier(Indicators.Stochastic, DataIdentifier.Data, StochasticDataParameters)
        Dim Stochastic1DataParameters() As Object = {14, 9, 3, AvgType.Exponential, 80.0, 20.0}
        Stochastic1Data = GetIndicatorIdentifier(Indicators.Stochastic, DataIdentifier.Data, Stochastic1DataParameters)
        Dim Stochastic2DataParameters() As Object = {45, 9, 14, AvgType.Exponential, 80.0, 20.0}
        Stochastic2Data = GetIndicatorIdentifier(Indicators.Stochastic, DataIdentifier.Data, Stochastic2DataParameters)
        Dim Stochastic3DataParameters() As Object = {75, 9, 20, AvgType.Exponential, 80.0, 20.0}
        Stochastic3Data = GetIndicatorIdentifier(Indicators.Stochastic, DataIdentifier.Data, Stochastic3DataParameters)
        StartBar = 0
        '#End Region

        '' Indicator creation sample
        '' avSimple = New AvSimple(Data, period, Price.Close)

        '' Enter your code here...
    End Sub

    ''' <summary>
    ''' Called on each bar update event.
    ''' </summary>
    ''' <param name="Bar">Bar index</param> 
    Public Overrides Sub OnCalculateBar(ByVal Bar As Integer)
        '#Region "PDV Code"
        SetIndicatorValue(((4.1 * GetIndicatorValue(StochasticData)) + (2.5 * GetIndicatorValue(Stochastic1Data)) + GetIndicatorValue(Stochastic2Data) + (4 * GetIndicatorValue(Stochastic3Data))) / 11.6, 1, 0)
        '#End Region

        '' Enter your code here...
    End Sub

#Region "Visual Chart Code"
    ''' <summary>
    ''' Performs calculus between startBar and endBar.
    ''' </summary>
    ''' <param name="InitBar">Initial calculus bar</param>
    ''' <param name="FinalBar">End calculus bar</param>  
    Public Overrides Sub OnCalculateRange(ByVal InitBar As Integer, ByVal FinalBar As Integer)
        Dim i As Long
        i = StartBar
        If InitBar > i Then
            i = InitBar
        End If
        While Not ShouldTerminate And i <= FinalBar
            CurrentBar = i
            CalculateAggregators()
            OnCalculateBar(i)
            i = i + 1
        End While
    End Sub

    ''' <summary>
    ''' Sets calculus parameters. 
    ''' </summary>
    ''' <param name="ParamList">Parameters list</param>   
    Public Overrides Sub OnSetParameters(ParamList As List(Of Object))
        '' Your code here...
    End Sub

    ''' <summary>
    ''' This function is used to create the data series corresponding to any indicator and to obtain an identifier of this series. To do so, we need to declare first a variable DataIdentifier type. Once the variable is defined we will always assign to it the the value of the functionGetIndicatorIdentifierin order to create the indicator data series and to obtain an identifier of the same indicator. The identifier of the indicator must be obtained from the procedure OnInitCalculate.
    ''' Later on, in order to obtain the value of an indicator we must use the functionGetIndicatorValueand indicate in the paramter Datathe variable on which we have saved the value of the correponding indicator. The identifier obtained by this function can be use don any .NET function on which a Data is required (Data series on which the different functions are calculated).
    ''' </summary>
    ''' <param name="indicator">Indicator Id.</param>
    ''' <param name="parentDataIdentifier">Identifier of the series on which the indicator is calculated. If we set this parameter as data, we will be calculating the indicator on the data or series on which the strategy is being calculated. If we are willing to obtain the identifier of an indicator being calculated on another indicator we shall indicate withing this parameter the identifier of the indicator we are willing to use as calculation.</param>
    ''' <param name="optionalParameters">Indicator parameters (Nulleable)</param>	
    ''' <returns>Indicator source identifier</returns>       
    Public Overloads Function GetIndicatorIdentifier(indicator As Indicators, parentDataIdentifier As DataIdentifier, ParamArray optionalParameters() As Object) As DataIdentifier
        GetIndicatorIdentifier = MyBase.GetIndicatorIdentifier(CType(indicator, Long), parentDataIdentifier, optionalParameters)
    End Function

    ''' <summary>
    ''' This function is used to create the data series corresponding to any indicator and to obtain an identifier of this series. To do so, we need to declare first a variable DataIdentifier type. Once the variable is defined we will always assign to it the the value of the functionGetIndicatorIdentifierin order to create the indicator data series and to obtain an identifier of the same indicator. The identifier of the indicator must be obtained from the procedure OnInitCalculate.
    ''' Later on, in order to obtain the value of an indicator we must use the functionGetIndicatorValueand indicate in the paramter Datathe variable on which we have saved the value of the correponding indicator. The identifier obtained by this function can be use don any .NET function on which a Data is required (Data series on which the different functions are calculated).
    ''' </summary>
    ''' <param name="indicator">Indicator Id.</param>
    ''' <param name="parentDataIdentifier">Identifier of the series on which the indicator is calculated. If we set this parameter as data, we will be calculating the indicator on the data or series on which the strategy is being calculated. If we are willing to obtain the identifier of an indicator being calculated on another indicator we shall indicate withing this parameter the identifier of the indicator we are willing to use as calculation.</param>
    ''' <param name="optionalParameters">Indicator parameters (Nulleable)</param>	
    ''' <returns>Indicator source identifier</returns>       
    Public Overloads Function GII(indicator As Indicators, parentDataIdentifier As DataIdentifier, ParamArray optionalParameters() As Object) As DataIdentifier
        GII = MyBase.GII(CType(indicator, Long), parentDataIdentifier, optionalParameters)
    End Function

    ''' <summary>
    ''' This function enables to obtain internally, the information of a certain system. This way, we can extract the information from this system without having to calculate it once and once again.
    ''' </summary>
    ''' <param name="strategy">Strategy id.</param>
    ''' <param name="parentDataIdentifier">Identifier of the series on which the system is calculated. If we set this parameter as data, we will be calculating the indicator on the data or series on which the strategy is being calculated. If we are willing to obtain the identifier of an indicator being calculated on another indicator we shall indicate withing this parameter the identifier of the indicator we are willing to use as calculation.</param>
    ''' <param name="optionalParameters">System parameters (Nulleable)</param>	
    ''' <returns>system source identifier</returns>
    Public Overloads Function GetSystemIdentifier(strategy As Strategies, parentDataIdentifier As DataIdentifier, ParamArray optionalParameters() As Object) As DataIdentifier
        GetSystemIdentifier = MyBase.GetSystemIdentifier(CType(strategy, Long), parentDataIdentifier, optionalParameters)
    End Function

    ''' <summary>
    ''' This function enables to obtain internally, the information of a certain system. This way, we can extract the information from this system without having to calculate it once and once again.
    ''' </summary>
    ''' <param name="strategy">Strategy id.</param>
    ''' <param name="parentDataIdentifier">Identifier of the series on which the system is calculated. If we set this parameter as data, we will be calculating the indicator on the data or series on which the strategy is being calculated. If we are willing to obtain the identifier of an indicator being calculated on another indicator we shall indicate withing this parameter the identifier of the indicator we are willing to use as calculation.</param>
    ''' <param name="optionalParameters">System parameters (Nulleable)</param>	
    ''' <returns>system source identifier</returns>
    Public Overloads Function GSYSI(strategy As Strategies, parentDataIdentifier As DataIdentifier, ParamArray optionalParameters() As Object) As DataIdentifier
        GSYSI = MyBase.GSYSI(CType(strategy, Long), parentDataIdentifier, optionalParameters)
    End Function

    ''' <summary>
    ''' This function is used to paint the background of the window, for a certain bar, in the indicated color.
    ''' </summary>    
    ''' <param name="barsAgo">Number of bars backwards.The value 0 refers to the current bar</param>
    ''' <param name="color">Color used for the bakground on the given bar(BarsAgo).</param>
    Public Overloads Sub SetBackgroundColor(BarsAgo As Integer, Color As Color)
        MyBase.SetBackgroundColor(BarsAgo, Color.FromArgb(0, Color.B, Color.G, Color.R).ToArgb())
    End Sub

    ''' <summary>
    ''' Assignsthe background color to the window of an indicator.
    ''' </summary>    	
    ''' <param name="color">Use of the function RGBto identify the background color of a window</param>
    Public Overloads Sub SetWndBackgroundColor(Color As Color)
        MyBase.SetWndBackgroundColor(Color.FromArgb(0, Color.B, Color.G, Color.R).ToArgb())
    End Sub

    ''' <summary>
    ''' This function assigns to the indicated bar of a certain indicator line, a certain color.
    ''' </summary>
    ''' <param name="barsAgo">Number of bars backwards.The value 0 refers to the current bar.</param>
    ''' <param name="line">Identifies the data line to which the bar on which the property is established belongs.</param>
    ''' <param name="color">Color to paint the indicated bar.</param>
    Public Overloads Sub SetBarColor(BarsAgo As Integer, Line As Integer, Color As Color)
        MyBase.SetBarColor(BarsAgo, Line, Color.FromArgb(0, Color.B, Color.G, Color.R).ToArgb())
    End Sub

    ''' <summary>
    ''' This function assigns to the indicated bar, of a certain line of the indicator, the color, width and type of line and also the representation used in the rest of the parameters.
    ''' </summary>
    ''' <param name="barsAgo">Number of bars backwards.The value 0 refers to the current bar.</param>
    ''' <param name="line">Identifies the data line to which the bar on which the property is established belongs</param>
    ''' <param name="color">Color to paint the indicated bar. FunctionRGB</param>
    ''' <param name="width">Indicates the width to be applied to the bar (1,2,..)</param>
    ''' <param name="style">Style used for the representation: lsSolid-> continuous line lsDash-> non-continuous line lsDot-> dotted line lsDashdot-> dotted line with point lsDashdotdot-> dotted line with 2 pointss</param>
    ''' <param name="representation">Type or representation bo be used: irBars-> bars irCandlestic-> candlesticks irDottedLine-> dotted line irFilledHistogram-> filled histogramm irHistogram-> histogramm irLineal-> lineal irParabolic-> parabOLIC irVolume-> volumen</param>		    
    Public Overloads Sub SetBarProperties(barsAgo As Integer, line As Integer, Color As Color, width As Integer, style As LineStyle, representation As IndicatorRepresentation)
        MyBase.SetBarProperties(barsAgo, line, Color.FromArgb(0, Color.B, Color.G, Color.R).ToArgb(), width, style, representation)
    End Sub

#End Region

End Class
